# Common make definitions for Caml programs

CAMLRUN=../camlrun
CAMLCOMP=../camlrun ../camlcomp
CAMLLINK=../camlrun ../camllink
CAMLLIBR=../camlrun ../camllibr
CAMLLEX=../camlrun ../camllex
CAMLYACC=../camlyacc -s
CPP=cpp -P -Dmsdos -Uunix

!if $d(STDLIB)
COMPFLAGS=-stdlib . -O none
LINKFLAGS=
!else
COMPFLAGS=-stdlib ../lib -W -O fast $(INCLUDES)
LINKFLAGS=-stdlib ../lib -g $(INCLUDES)
!endif

clean:
	rm -f $(OUTPUT) $(GENSOURCES)
	rm -f *.zo *.zi *.zix

version.ml: version.mlp ../version.h
	$(CPP) version.mlp > version.ml

.mli.zi:
	$(CAMLCOMP) $(COMPFLAGS) {$< }

.ml.zo:
	$(CAMLCOMP) $(COMPFLAGS) {$< }

.mlp.ml:
	$(CPP) $< > $*.ml

.mll.ml:
	$(CAMLLEX) $<

.mly.ml:
	$(CAMLYACC) $<

.mly.mli:
	$(CAMLYACC) $<

depend: $(GENSOURCES)
	mv makefile makefile.bak
	perl ../tools/cutdeps makefile.bak > makefile
	perl ../tools/camldep $(INCLUDES) >> makefile
	rm -f makefile.bak
